'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _helpers = require('./helpers');

var isValidPage = function isValidPage(props, propName, componentName) {
  var page = props[propName];
  var totalPages = props.totalPages;

  if (!page) return new Error((0, _helpers.getMessageErrorRequired)({ propName: propName, componentName: componentName }));
  if (typeof page !== 'number') return new Error((0, _helpers.getMessageErrorNumber)({ propName: propName, componentName: componentName }));
  if (page <= 0) return new Error((0, _helpers.getMessageErrorPositive)({ propName: propName, componentName: componentName }));
  if (page > totalPages) return new Error((0, _helpers.getMessageErrorInRange)({ propName: propName, componentName: componentName }));

  // assume all ok
  return null;
};

exports.default = isValidPage;