'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _helpers = require('./helpers');

var isValidShowPages = function isValidShowPages(props, propName, componentName) {
  var showPages = props[propName];
  var totalPages = props.totalPages;

  if (!showPages) return new Error((0, _helpers.getMessageErrorRequired)({ propName: propName, componentName: componentName }));
  if (typeof showPages !== 'number') return new Error((0, _helpers.getMessageErrorNumber)({ propName: propName, componentName: componentName }));
  if (showPages <= 0) return new Error((0, _helpers.getMessageErrorPositive)({ propName: propName, componentName: componentName }));
  if (showPages > totalPages) return new Error((0, _helpers.getMessageErrorInRange)({ propName: propName, componentName: componentName }));

  // assume all ok
  return null;
};

exports.default = isValidShowPages;