'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _helpers = require('./helpers');

var isValidTotalPages = function isValidTotalPages(props, propName, componentName) {
  var totalPages = props[propName];
  if (!totalPages) return new Error((0, _helpers.getMessageErrorRequired)({ propName: propName, componentName: componentName }));
  if (typeof totalPages !== 'number') return new Error((0, _helpers.getMessageErrorNumber)({ propName: propName, componentName: componentName }));
  if (totalPages <= 0) return new Error((0, _helpers.getMessageErrorPositive)({ propName: propName, componentName: componentName }));

  // assume all ok
  return null;
};

exports.default = isValidTotalPages;