'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _from = require('babel-runtime/core-js/array/from');

var _from2 = _interopRequireDefault(_from);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _lowRange2 = require('./lowRange');

var _lowRange3 = _interopRequireDefault(_lowRange2);

var _highRange2 = require('./highRange');

var _highRange3 = _interopRequireDefault(_highRange2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Gets the proper range for the page number according to the number of pages to display
 * @param {object} params - parameters pagination
 * @param {number} params.page - Original page number
 * @param {number} params.totalPages - Total number of pages
 * @param {number} params.showPages - Number of pages to display in the range of pages displayed
 * @return {number[]} range of page numbers
 */
var range = function range(_ref) {
  var page = _ref.page,
      totalPages = _ref.totalPages,
      showPages = _ref.showPages;

  var _lowRange = (0, _lowRange3.default)({ page: page, showPages: showPages });
  var _highRange = (0, _highRange3.default)({ page: page, totalPages: totalPages, showPages: showPages });
  var rangeNumItems = _highRange === totalPages ? totalPages - _lowRange : showPages;
  return [].concat((0, _toConsumableArray3.default)((0, _from2.default)(new Array(rangeNumItems), function (_, i) {
    return _lowRange + i + 1;
  })));
};

exports.default = range;