'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactMoleculeButtonGroup = require('@s-ui/react-molecule-button-group');

var _reactMoleculeButtonGroup2 = _interopRequireDefault(_reactMoleculeButtonGroup);

var _suiAtomButton = require('@schibstedspain/sui-atom-button');

var _suiAtomButton2 = _interopRequireDefault(_suiAtomButton);

var _pagination = require('./helpers/pagination');

var pagination = _interopRequireWildcard(_pagination);

var _customPropTypes = require('./customPropTypes');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BASE_CLASS = 'sui-MoleculePagination';
var CLASS_PREV_BUTTON_ICON = 'sui-MoleculePagination-prevButtonIcon';
var CLASS_NEXT_BUTTON_ICON = 'sui-MoleculePagination-nextButtonIcon';

// eslint-disable-next-line react/prop-types
var PageButton = function PageButton(_ref) {
  var onSelectPage = _ref.onSelectPage,
      page = _ref.page,
      props = (0, _objectWithoutProperties3.default)(_ref, ['onSelectPage', 'page']);

  var _onSelectPage = function _onSelectPage(e) {
    onSelectPage(e, { page: page });
  };
  return _react2.default.createElement(_suiAtomButton2.default, (0, _extends3.default)({ onClick: _onSelectPage }, props));
};

var MoleculePagination = function (_Component) {
  (0, _inherits3.default)(MoleculePagination, _Component);

  function MoleculePagination() {
    var _ref2;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, MoleculePagination);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref2 = MoleculePagination.__proto__ || (0, _getPrototypeOf2.default)(MoleculePagination)).call.apply(_ref2, [this].concat(args))), _this), _this.handleClickNext = function (e) {
      var _this$props = _this.props,
          onSelectNext = _this$props.onSelectNext,
          props = (0, _objectWithoutProperties3.default)(_this$props, ['onSelectNext']);

      var page = pagination.nextPage(props);
      onSelectNext(e, { page: page });
    }, _this.handleClickPrev = function (e) {
      var _this$props2 = _this.props,
          onSelectPrev = _this$props2.onSelectPrev,
          props = (0, _objectWithoutProperties3.default)(_this$props2, ['onSelectPrev']);

      var page = pagination.prevPage(props);
      onSelectPrev(e, { page: page });
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(MoleculePagination, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          page = _props.page,
          totalPages = _props.totalPages,
          showPages = _props.showPages,
          prevButtonText = _props.prevButtonText,
          PrevButtonIcon = _props.prevButtonIcon,
          nextButtonText = _props.nextButtonText,
          NextButtonIcon = _props.nextButtonIcon,
          onSelectPage = _props.onSelectPage,
          compressed = _props.compressed,
          hideDisabled = _props.hideDisabled;


      var paramsPagination = {
        page: page,
        totalPages: totalPages,
        showPages: showPages
      };

      var range = pagination.range(paramsPagination);
      var nextPage = pagination.nextPage(paramsPagination);
      var prevPage = pagination.prevPage(paramsPagination);

      var isHidePrev = hideDisabled && !prevPage;
      var isHideNext = hideDisabled && !nextPage;

      return _react2.default.createElement(
        'div',
        { className: BASE_CLASS },
        _react2.default.createElement(
          _reactMoleculeButtonGroup2.default,
          { type: 'tertiary' },
          !isHidePrev && _react2.default.createElement(
            _suiAtomButton2.default,
            { onClick: this.handleClickPrev, disabled: !prevPage },
            PrevButtonIcon && _react2.default.createElement(
              'span',
              { className: CLASS_PREV_BUTTON_ICON },
              _react2.default.createElement(PrevButtonIcon, null)
            ),
            prevButtonText
          ),
          compressed ? _react2.default.createElement(
            PageButton,
            { page: page, focused: true, onSelectPage: onSelectPage },
            page
          ) : range.map(function (pageRange) {
            return _react2.default.createElement(
              PageButton,
              {
                key: pageRange,
                page: pageRange,
                focused: pageRange === page,
                onSelectPage: onSelectPage
              },
              pageRange
            );
          }),
          !isHideNext && _react2.default.createElement(
            _suiAtomButton2.default,
            { onClick: this.handleClickNext, disabled: !nextPage },
            nextButtonText,
            NextButtonIcon && _react2.default.createElement(
              'span',
              { className: CLASS_NEXT_BUTTON_ICON },
              _react2.default.createElement(NextButtonIcon, null)
            )
          )
        )
      );
    }
  }]);
  return MoleculePagination;
}(_react.Component);

MoleculePagination.displayName = 'MoleculePagination';

MoleculePagination.propTypes = process.env.NODE_ENV !== "production" ? process.env.NODE_ENV !== "production" ? {
  /** Total number of pages */
  totalPages: _customPropTypes.isValidTotalPages,

  /** Current page selected */
  page: _customPropTypes.isValidPage,

  /** Number of pages to be displayed in the range (10 by default) */
  showPages: _customPropTypes.isValidShowPages,

  /** If the pagination should be displayed in compressed mode or not */
  compressed: _propTypes2.default.bool,

  /** Text to be displayed on the previous button */
  prevButtonText: _propTypes2.default.string,

  /** Icon to be displayed on the previous button */
  prevButtonIcon: _propTypes2.default.any,

  /** Text to be displayed on the next button */
  nextButtonText: _propTypes2.default.string,

  /** Icon to be displayed on the next button */
  nextButtonIcon: _propTypes2.default.any,

  /** Callback that will be called with (event, page) on prev button click */
  onSelectPrev: _propTypes2.default.func,

  /** Callback that will be called with (event, page) on next button click */
  onSelectNext: _propTypes2.default.func,

  /** Callback that will be called with (event, page) on each page button click */
  onSelectPage: _propTypes2.default.func,

  /** Hide Previous/Next buttons if they're disabled */
  hideDisabled: _propTypes2.default.bool
} : {} : {};

MoleculePagination.defaultProps = {
  showPages: 10,
  compressed: false,
  prevButtonText: 'Previous',
  nextButtonText: 'Next',
  onSelectPrev: function onSelectPrev() {},
  onSelectNext: function onSelectNext() {},
  onSelectPage: function onSelectPage() {}
};

exports.default = MoleculePagination;